<?php

namespace dgsoft\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AncillaryTicketRemarkType StructType
 * @package Dg
 * @subpackage Structs
 */
class DgAncillaryTicketRemarkType extends AbstractStructBase
{
    /**
     * The RemarkTypeCode
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $RemarkTypeCode;
    /**
     * The RemarkType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $RemarkType;
    /**
     * The Remark
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Remark;
    /**
     * Constructor method for AncillaryTicketRemarkType
     * @uses DgAncillaryTicketRemarkType::setRemarkTypeCode()
     * @uses DgAncillaryTicketRemarkType::setRemarkType()
     * @uses DgAncillaryTicketRemarkType::setRemark()
     * @param string $remarkTypeCode
     * @param string $remarkType
     * @param string $remark
     */
    public function __construct($remarkTypeCode = null, $remarkType = null, $remark = null)
    {
        $this
            ->setRemarkTypeCode($remarkTypeCode)
            ->setRemarkType($remarkType)
            ->setRemark($remark);
    }
    /**
     * Get RemarkTypeCode value
     * @return string|null
     */
    public function getRemarkTypeCode()
    {
        return $this->RemarkTypeCode;
    }
    /**
     * Set RemarkTypeCode value
     * @param string $remarkTypeCode
     * @return \dgsoft\StructType\DgAncillaryTicketRemarkType
     */
    public function setRemarkTypeCode($remarkTypeCode = null)
    {
        // validation for constraint: string
        if (!is_null($remarkTypeCode) && !is_string($remarkTypeCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($remarkTypeCode)), __LINE__);
        }
        $this->RemarkTypeCode = $remarkTypeCode;
        return $this;
    }
    /**
     * Get RemarkType value
     * @return string|null
     */
    public function getRemarkType()
    {
        return $this->RemarkType;
    }
    /**
     * Set RemarkType value
     * @param string $remarkType
     * @return \dgsoft\StructType\DgAncillaryTicketRemarkType
     */
    public function setRemarkType($remarkType = null)
    {
        // validation for constraint: string
        if (!is_null($remarkType) && !is_string($remarkType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($remarkType)), __LINE__);
        }
        $this->RemarkType = $remarkType;
        return $this;
    }
    /**
     * Get Remark value
     * @return string|null
     */
    public function getRemark()
    {
        return $this->Remark;
    }
    /**
     * Set Remark value
     * @param string $remark
     * @return \dgsoft\StructType\DgAncillaryTicketRemarkType
     */
    public function setRemark($remark = null)
    {
        // validation for constraint: string
        if (!is_null($remark) && !is_string($remark)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($remark)), __LINE__);
        }
        $this->Remark = $remark;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\StructType\DgAncillaryTicketRemarkType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
